#version 420

layout(triangles,invocations=4) in;
layout(triangle_strip,max_vertices=3) out;

layout (location=0) in vec3 Colour[];

out NVertex {
  vec3 Colour;
  vec3 Position;
  vec3 Normal;
} Out;

uniform TransBlock {
    mat4 mm, vm, pm, vpm;
    vec4 eyepos;
  } trb;

void main ( void )
{
  int  i;
  vec3 v1, v2, nv;
  vec4 Pos, t;

  v1 = gl_in[1].gl_Position.xyz - gl_in[0].gl_Position.xyz;
  v2 = gl_in[2].gl_Position.xyz - gl_in[0].gl_Position.xyz;
  nv = normalize ( cross ( v1, v2 ) );
  t = vec4 ( ((gl_InvocationID+1)*0.05)*nv, 0.0 );
  for ( i = 0; i < 3; i++ ) {
    Pos = gl_in[i].gl_Position + t;
    gl_Position = trb.vpm * Pos;
    Out.Position = Pos.xyz;
    Out.Normal = nv;
    Out.Colour = Colour[i];
    EmitVertex ();
  }
  EndPrimitive ();
} /*main*/
