#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "openglheader.h"

#include "utilities.h"
#include "trans.h"

#define NTRUOFFS 5

GLuint       trbbp;
GLint        trbsize;
static GLint trbofs[NTRUOFFS];

const GLchar *UTBNames[] =
  { "TransBlock", "TransBlock.mm", "TransBlock.vm", "TransBlock.pm",
    "TransBlock.vpm", "TransBlock.eyepos" };

GLuint GetAccessToTransBlockUniform ( GLuint program_id )
{
  GetAccessToUniformBlock ( program_id, NTRUOFFS, &UTBNames[0],
                            &trbsize, trbofs, &trbbp );
  return trbbp;
} /*GetAccessToTransBlockUniform*/

void LoadVPMatrix ( GLuint trbuf, TransBl *trans )
{
  GLfloat vpm[16];

  glBindBuffer ( GL_UNIFORM_BUFFER, trbuf );
  M4x4Multf ( vpm, trans->pm, trans->vm );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[1], 16*sizeof(GLfloat), trans->vm );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[2], 16*sizeof(GLfloat), trans->pm );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[3], 16*sizeof(GLfloat), vpm );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[4], 4*sizeof(GLfloat), trans->eyepos );
  ExitIfGLError ( "LoadVPMatrix" );
} /*LoadVPMatrix*/

void LoadMMatrix ( GLuint trbuf, TransBl *trans )
{
  glBindBuffer ( GL_UNIFORM_BUFFER, trbuf );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[0], 16*sizeof(GLfloat), trans->mm );
  ExitIfGLError ( "LoadMMatrix" );
} /*LoadMMatrix*/

